DROP SEQUENCE WEB_CRAWLING_CONFIG_SEQ;
DROP SEQUENCE FILE_CRAWLING_CONFIG_SEQ;
DROP SEQUENCE JOB_LOG_SEQ;
DROP SEQUENCE SCHEDULED_JOB_SEQ;
DROP SEQUENCE PATH_MAPPING_SEQ;
DROP SEQUENCE CRAWLING_SESSION_SEQ;
DROP SEQUENCE OVERLAPPING_HOST_SEQ;
DROP SEQUENCE REQUEST_HEADER_SEQ;
DROP SEQUENCE KEY_MATCH_SEQ;
DROP SEQUENCE BOOST_DOCUMENT_RULE_SEQ;
DROP SEQUENCE WEB_AUTHENTICATION_SEQ;
DROP SEQUENCE CRAWLING_SESSION_INFO_SEQ;
DROP SEQUENCE LABEL_TYPE_SEQ;
DROP SEQUENCE FILE_CONFIG_TO_LABEL_TYPE_SEQ;
DROP SEQUENCE WEB_CONFIG_TO_LABEL_TYPE_SEQ;
DROP SEQUENCE ROLE_TYPE_SEQ;
DROP SEQUENCE FILE_CONFIG_TO_ROLE_TYPE_SEQ;
DROP SEQUENCE WEB_CONFIG_TO_ROLE_TYPE_SEQ;
DROP SEQUENCE DATA_CRAWLING_CONFIG_SEQ;
DROP SEQUENCE DATA_CONFIG_TO_ROLE_TYPE_SEQ;
DROP SEQUENCE DATA_CONFIG_TO_LABEL_TYPE_SEQ;
DROP SEQUENCE USER_INFO_SEQ;
DROP SEQUENCE SEARCH_LOG_SEQ;
DROP SEQUENCE LABEL_TYPE_TO_ROLE_TYPE_SEQ;
DROP SEQUENCE CLICK_LOG_SEQ;
DROP SEQUENCE FAILURE_URL_SEQ;
DROP SEQUENCE FILE_AUTHENTICATION_SEQ;
DROP SEQUENCE SEARCH_FIELD_LOG_SEQ;
DROP SEQUENCE FAVORITE_LOG_SEQ;
DROP SEQUENCE SUGGEST_BAD_WORD;
DROP SEQUENCE SUGGEST_ELAVATE_WORD;

DROP TABLE "FAVORITE_LOG";
DROP TABLE "SEARCH_FIELD_LOG";
DROP TABLE "FILE_AUTHENTICATION";
DROP TABLE "FAILURE_URL";
DROP TABLE "CLICK_LOG";
DROP TABLE "LABEL_TYPE_TO_ROLE_TYPE";
DROP TABLE "SEARCH_LOG";
DROP TABLE "USER_INFO";
DROP TABLE "DATA_CONFIG_TO_LABEL_TYPE";
DROP TABLE "DATA_CONFIG_TO_ROLE_TYPE";
DROP TABLE "DATA_CRAWLING_CONFIG";
DROP TABLE "WEB_CONFIG_TO_ROLE_TYPE";
DROP TABLE "FILE_CONFIG_TO_ROLE_TYPE";
DROP TABLE "ROLE_TYPE";
DROP TABLE "WEB_CONFIG_TO_LABEL_TYPE";
DROP TABLE "FILE_CONFIG_TO_LABEL_TYPE";
DROP TABLE "LABEL_TYPE";
DROP TABLE "CRAWLING_SESSION_INFO";
DROP TABLE "WEB_AUTHENTICATION";
DROP TABLE "KEY_MATCH";
DROP TABLE "BOOST_DOCUMENT_RULE";
DROP TABLE "REQUEST_HEADER";
DROP TABLE "OVERLAPPING_HOST";
DROP TABLE "CRAWLING_SESSION";
DROP TABLE "PATH_MAPPING";
DROP TABLE "SCHEDULED_JOB";
DROP TABLE "JOB_LOG";
DROP TABLE "FILE_CRAWLING_CONFIG";
DROP TABLE "WEB_CRAWLING_CONFIG";
DROP TABLE "SUGGEST_BAD_WORD";
DROP TABLE "SUGGEST_ELAVATE_WORD";

CREATE TABLE "WEB_CRAWLING_CONFIG"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(200) NOT NULL,
  "URLS" VARCHAR2(4000) NOT NULL,
  "INCLUDED_URLS" VARCHAR2(4000),
  "EXCLUDED_URLS" VARCHAR2(4000),
  "INCLUDED_DOC_URLS" VARCHAR2(4000),
  "EXCLUDED_DOC_URLS" VARCHAR2(4000),
  "CONFIG_PARAMETER" VARCHAR2(4000),
  "DEPTH" NUMBER(7,0),
  "MAX_ACCESS_COUNT" NUMBER(18,0),
  "USER_AGENT" VARCHAR2(200) NOT NULL,
  "NUM_OF_THREAD" NUMBER(9,0) NOT NULL,
  "INTERVAL_TIME" NUMBER(9,0) NOT NULL,
  "BOOST" FLOAT NOT NULL,
  "AVAILABLE" VARCHAR2(1) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "WEB_CRAWLING_CONFIG_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "FILE_CRAWLING_CONFIG"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(200) NOT NULL,
  "PATHS" VARCHAR2(4000) NOT NULL,
  "INCLUDED_PATHS" VARCHAR2(4000),
  "EXCLUDED_PATHS" VARCHAR2(4000),
  "INCLUDED_DOC_PATHS" VARCHAR2(4000),
  "EXCLUDED_DOC_PATHS" VARCHAR2(4000),
  "CONFIG_PARAMETER" VARCHAR2(4000),
  "DEPTH" NUMBER(9,0),
  "MAX_ACCESS_COUNT" NUMBER(18,0),
  "NUM_OF_THREAD" NUMBER(9,0) NOT NULL,
  "INTERVAL_TIME" NUMBER(9,0) NOT NULL,
  "BOOST" FLOAT NOT NULL,
  "AVAILABLE" VARCHAR2(1) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "FILE_CRAWLING_CONFIG_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "SCHEDULED_JOB"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(100) NOT NULL,
  "TARGET" VARCHAR2(100) NOT NULL,
  "CRON_EXPRESSION" VARCHAR2(100) NOT NULL,
  "SCRIPT_TYPE" VARCHAR2(100) NOT NULL,
  "SCRIPT_DATA" VARCHAR2(4000),
  "CRAWLER" VARCHAR2(1) NOT NULL,
  "JOB_LOGGING" VARCHAR2(1) NOT NULL,
  "AVAILABLE" VARCHAR2(1) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "SCHEDULED_JOB_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "JOB_LOG"(
  "ID" NUMBER(18,0) NOT NULL,
  "JOB_NAME" VARCHAR2(100) NOT NULL,
  "JOB_STATUS" VARCHAR2(10) NOT NULL,
  "TARGET" VARCHAR2(100) NOT NULL,
  "SCRIPT_TYPE" VARCHAR2(100) NOT NULL,
  "SCRIPT_DATA" VARCHAR2(4000),
  "SCRIPT_RESULT" VARCHAR2(4000),
  "START_TIME" TIMESTAMP NOT NULL,
  "END_TIME" TIMESTAMP,

  CONSTRAINT "JOB_LOG_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "PATH_MAPPING"(
  "ID" NUMBER(18,0) NOT NULL,
  "REGEX" VARCHAR2(1000) NOT NULL,
  "REPLACEMENT" VARCHAR2(1000) NOT NULL,
  "PROCESS_TYPE" VARCHAR2(1) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "PATH_MAPPING_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "CRAWLING_SESSION"(
  "ID" NUMBER(18,0) NOT NULL,
  "SESSION_ID" VARCHAR2(20) NOT NULL,
  "NAME" VARCHAR2(20),
  "EXPIRED_TIME" TIMESTAMP,
  "CREATED_TIME" TIMESTAMP NOT NULL,

  CONSTRAINT "CRAWLING_SESSION_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "OVERLAPPING_HOST"(
  "ID" NUMBER(18,0) NOT NULL,
  "REGULAR_NAME" VARCHAR2(1000) NOT NULL,
  "OVERLAPPING_NAME" VARCHAR2(1000) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "OVERLAPPING_HOST_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "REQUEST_HEADER"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(100) NOT NULL,
  "VALUE" VARCHAR2(1000) NOT NULL,
  "WEB_CRAWLING_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "REQUEST_HEADER_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (WEB_CRAWLING_CONFIG_ID) REFERENCES WEB_CRAWLING_CONFIG (ID)
);

CREATE TABLE "BOOST_DOCUMENT_RULE"(
  "ID" NUMBER(18,0) NOT NULL,
  "URL_EXPR" VARCHAR2(4000) NOT NULL,
  "BOOST_EXPR" VARCHAR2(4000) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "BOOST_DOCUMENT_RULE_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "KEY_MATCH"(
  "ID" NUMBER(18,0) NOT NULL,
  "TERM" VARCHAR2(100) NOT NULL,
  "QUERY" VARCHAR2(4000) NOT NULL,
  "MAX_SIZE" NUMBER(9,0) NOT NULL,
  "BOOST" FLOAT NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "KEY_MATCH_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "WEB_AUTHENTICATION"(
  "ID" NUMBER(18,0) NOT NULL,
  "HOSTNAME" VARCHAR2(100),
  "PORT" NUMBER(9,0) NOT NULL,
  "AUTH_REALM" VARCHAR2(100),
  "PROTOCOL_SCHEME" VARCHAR2(10),
  "USERNAME" VARCHAR2(100) NOT NULL,
  "PASSWORD" VARCHAR2(100),
  "PARAMETERS" VARCHAR2(1000),
  "WEB_CRAWLING_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "WEB_AUTHENTICATION_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (WEB_CRAWLING_CONFIG_ID) REFERENCES WEB_CRAWLING_CONFIG (ID)
);

CREATE TABLE "CRAWLING_SESSION_INFO"(
  "ID" NUMBER(18,0) NOT NULL,
  "CRAWLING_SESSION_ID" NUMBER(18,0) NOT NULL,
  "KEY" VARCHAR2(20) NOT NULL,
  "VALUE" VARCHAR2(100) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,

  CONSTRAINT "CRAWLING_SESSION_INFO_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (CRAWLING_SESSION_ID) REFERENCES CRAWLING_SESSION (ID)
);

CREATE TABLE "LABEL_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(100) NOT NULL,
  "VALUE" VARCHAR2(20) NOT NULL,
  "INCLUDED_PATHS" VARCHAR2(4000),
  "EXCLUDED_PATHS" VARCHAR2(4000),
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "LABEL_TYPE_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "FILE_CONFIG_TO_LABEL_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "FILE_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "LABEL_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "FILE_CONFIG_TO_LABEL_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (LABEL_TYPE_ID) REFERENCES LABEL_TYPE (ID),
  FOREIGN KEY (FILE_CONFIG_ID) REFERENCES FILE_CRAWLING_CONFIG (ID)
);

CREATE TABLE "WEB_CONFIG_TO_LABEL_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "WEB_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "LABEL_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "WEB_CONFIG_TO_LABEL_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (LABEL_TYPE_ID) REFERENCES LABEL_TYPE (ID),
  FOREIGN KEY (WEB_CONFIG_ID) REFERENCES WEB_CRAWLING_CONFIG (ID)
);

CREATE TABLE "ROLE_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(100) NOT NULL,
  "VALUE" VARCHAR2(20) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "ROLE_TYPE_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "FILE_CONFIG_TO_ROLE_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "FILE_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "ROLE_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "FILE_CONFIG_TO_ROLE_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (FILE_CONFIG_ID) REFERENCES FILE_CRAWLING_CONFIG (ID),
  FOREIGN KEY (ROLE_TYPE_ID) REFERENCES ROLE_TYPE (ID)
);

CREATE TABLE "WEB_CONFIG_TO_ROLE_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "WEB_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "ROLE_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "WEB_CONFIG_TO_ROLE_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (WEB_CONFIG_ID) REFERENCES WEB_CRAWLING_CONFIG (ID),
  FOREIGN KEY (ROLE_TYPE_ID) REFERENCES ROLE_TYPE (ID)
);

CREATE TABLE "DATA_CRAWLING_CONFIG"(
  "ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(200) NOT NULL,
  "HANDLER_NAME" VARCHAR2(200) NOT NULL,
  "HANDLER_PARAMETER" VARCHAR2(4000),
  "HANDLER_SCRIPT" VARCHAR2(4000),
  "BOOST" FLOAT NOT NULL,
  "AVAILABLE" VARCHAR2(1) NOT NULL,
  "SORT_ORDER" NUMBER(9,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "DATA_CRAWLING_CONFIG_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "DATA_CONFIG_TO_ROLE_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "DATA_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "ROLE_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "DATA_CONFIG_TO_ROLE_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (DATA_CONFIG_ID) REFERENCES DATA_CRAWLING_CONFIG (ID),
  FOREIGN KEY (ROLE_TYPE_ID) REFERENCES ROLE_TYPE (ID)
);

CREATE TABLE "DATA_CONFIG_TO_LABEL_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "DATA_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "LABEL_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "DATA_CONFIG_TO_LABEL_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (DATA_CONFIG_ID) REFERENCES DATA_CRAWLING_CONFIG (ID),
  FOREIGN KEY (LABEL_TYPE_ID) REFERENCES LABEL_TYPE (ID)
);

CREATE TABLE "USER_INFO" (
  "ID" NUMBER(18,0) NOT NULL,
  "CODE" VARCHAR2(1000) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_TIME" TIMESTAMP NOT NULL,

  CONSTRAINT "USER_INFO_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "SEARCH_LOG"(
  "ID" NUMBER(18,0) NOT NULL,
  "SEARCH_WORD" VARCHAR2(1000),
  "REQUESTED_TIME" TIMESTAMP NOT NULL,
  "RESPONSE_TIME" NUMBER(9,0) NOT NULL,
  "HIT_COUNT" NUMBER(18,0) NOT NULL,
  "QUERY_OFFSET" NUMBER(9,0) NOT NULL,
  "QUERY_PAGE_SIZE" NUMBER(9,0) NOT NULL,
  "USER_AGENT" VARCHAR2(255),
  "REFERER" VARCHAR2(1000),
  "CLIENT_IP" VARCHAR2(50),
  "USER_SESSION_ID" VARCHAR2(100),
  "ACCESS_TYPE" VARCHAR2(1) NOT NULL,
  "USER_ID" NUMBER(18,0),

  CONSTRAINT "SEARCH_LOG_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (USER_ID) REFERENCES USER_INFO (ID)
);

CREATE TABLE "LABEL_TYPE_TO_ROLE_TYPE"(
  "ID" NUMBER(18,0) NOT NULL,
  "LABEL_TYPE_ID" NUMBER(18,0) NOT NULL,
  "ROLE_TYPE_ID" NUMBER(18,0) NOT NULL,

  CONSTRAINT "LABEL_TYPE_TO_ROLE_TYPE_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (LABEL_TYPE_ID) REFERENCES LABEL_TYPE (ID),
  FOREIGN KEY (ROLE_TYPE_ID) REFERENCES ROLE_TYPE (ID)
);

CREATE TABLE "CLICK_LOG"(
  "ID" NUMBER(18,0) NOT NULL,
  "SEARCH_ID" NUMBER(18,0) NOT NULL,
  "URL" VARCHAR2(4000) NOT NULL,
  "REQUESTED_TIME" TIMESTAMP NOT NULL,

  CONSTRAINT "CLICK_LOG_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (SEARCH_ID) REFERENCES SEARCH_LOG (ID)
);

CREATE TABLE "FAILURE_URL"(
  "ID" NUMBER(18,0) NOT NULL,
  "URL" VARCHAR2(4000) NOT NULL,
  "THREAD_NAME" VARCHAR2(30) NOT NULL,
  "ERROR_NAME" VARCHAR2(255),
  "ERROR_LOG" VARCHAR2(4000),
  "ERROR_COUNT" NUMBER(9,0) NOT NULL,
  "LAST_ACCESS_TIME" TIMESTAMP NOT NULL,
  "CONFIG_ID" VARCHAR2(100),

  CONSTRAINT "FAILURE_URL_PK" PRIMARY KEY ("ID") ENABLE
);

CREATE TABLE "FILE_AUTHENTICATION"(
  "ID" NUMBER(18,0) NOT NULL,
  "HOSTNAME" VARCHAR2(255),
  "PORT" NUMBER(9,0) NOT NULL,
  "PROTOCOL_SCHEME" VARCHAR2(10),
  "USERNAME" VARCHAR2(100) NOT NULL,
  "PASSWORD" VARCHAR2(100),
  "PARAMETERS" VARCHAR2(1000),
  "FILE_CRAWLING_CONFIG_ID" NUMBER(18,0) NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "FILE_AUTHENTICATION_PK" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (FILE_CRAWLING_CONFIG_ID) REFERENCES FILE_CRAWLING_CONFIG (ID)
);

CREATE TABLE "SEARCH_FIELD_LOG" (
  "ID" NUMBER(18,0) NOT NULL,
  "SEARCH_ID" NUMBER(18,0) NOT NULL,
  "NAME" VARCHAR2(255) NOT NULL,
  "VALUE" VARCHAR2(4000) NOT NULL,

  CONSTRAINT "SEARCH_FIELD_LOG" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (SEARCH_ID) REFERENCES SEARCH_LOG (ID)
);

CREATE TABLE "FAVORITE_LOG" (
  "ID" NUMBER(18,0) NOT NULL,
  "USER_ID" NUMBER(18,0) NOT NULL,
  "URL" VARCHAR2(4000) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,

  CONSTRAINT "FAVORITE_LOG" PRIMARY KEY ("ID") ENABLE,
  FOREIGN KEY (USER_ID) REFERENCES USER_INFO (ID)
);

/**********************************/
/* Table Name: Suggest Ng Word */
/**********************************/
CREATE TABLE "SUGGEST_BAD_WORD" (
  "ID" NUMBER(18,0) NOT NULL,
  "SUGGEST_WORD" VARCHAR2(255) NOT NULL,
  "TARGET_ROLE" VARCHAR2(255),
  "TARGET_LABEL" VARCHAR2(255),
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "SUGGEST_BAD_WORD" PRIMARY KEY ("ID") ENABLE
);

/**********************************/
/* Table Name: Suggest Elevate word */
/**********************************/
CREATE TABLE "SUGGEST_ELEVATE_WORD" (
  "ID" NUMBER(18,0) NOT NULL,
  "SUGGEST_WORD" VARCHAR2(255) NOT NULL,
  "READING" VARCHAR2(255),
  "TARGET_ROLE" VARCHAR2(255),
  "TARGET_LABEL" VARCHAR2(255),
  "BOOST" FLOAT NOT NULL,
  "CREATED_BY" VARCHAR2(255) NOT NULL,
  "CREATED_TIME" TIMESTAMP NOT NULL,
  "UPDATED_BY" VARCHAR2(255),
  "UPDATED_TIME" TIMESTAMP,
  "DELETED_BY" VARCHAR2(255),
  "DELETED_TIME" TIMESTAMP,
  "VERSION_NO" NUMBER(9,0) NOT NULL,

  CONSTRAINT "SUGGEST_ELEVATE_WORD" PRIMARY KEY ("ID") ENABLE
);

CREATE UNIQUE INDEX UQ_FAVORITE_LOG ON FAVORITE_LOG (USER_ID, URL);

CREATE INDEX IDX_O_H_BY_R_N_AND_S_O ON OVERLAPPING_HOST (REGULAR_NAME, SORT_ORDER);

CREATE INDEX IDX_F_C_TO_L_T_FOR_F_C ON FILE_CONFIG_TO_LABEL_TYPE (FILE_CONFIG_ID);

CREATE INDEX IDX_W_C_TO_L_T_FOR_W_C ON WEB_CONFIG_TO_LABEL_TYPE (WEB_CONFIG_ID);

CREATE INDEX IDX_F_C_TO_R_T_FOR_F_C ON FILE_CONFIG_TO_ROLE_TYPE (FILE_CONFIG_ID);

CREATE INDEX IDX_W_C_TO_R_T_FOR_W_C ON WEB_CONFIG_TO_ROLE_TYPE (WEB_CONFIG_ID);

CREATE INDEX IDX_D_C_TO_R_T_FOR_D_C ON DATA_CONFIG_TO_ROLE_TYPE (DATA_CONFIG_ID);

CREATE INDEX IDX_D_C_TO_L_T_FOR_D_C ON DATA_CONFIG_TO_LABEL_TYPE (DATA_CONFIG_ID);

CREATE INDEX IDX_S_L_BY_H_C ON SEARCH_LOG (HIT_COUNT);
CREATE INDEX IDX_S_L_BY_R_T ON SEARCH_LOG (RESPONSE_TIME);
CREATE INDEX IDX_S_L_BY_RT ON SEARCH_LOG (REQUESTED_TIME);
CREATE INDEX IDX_S_L_BY_S_W ON SEARCH_LOG (SEARCH_WORD);
CREATE INDEX IDX_S_L_BY_RT_USID ON SEARCH_LOG (REQUESTED_TIME, USER_SESSION_ID);
CREATE INDEX IDX_S_L_BY_USID ON SEARCH_LOG (USER_ID);

CREATE INDEX IDX_C_L_URL ON CLICK_LOG (URL);

CREATE INDEX IDX_F_U_FOR_L ON FAILURE_URL (URL, LAST_ACCESS_TIME, ERROR_NAME, ERROR_COUNT);
CREATE INDEX IDX_F_U_BY_W_C_ID ON FAILURE_URL (CONFIG_ID);

CREATE INDEX IDX_S_F_LOG_NAME ON SEARCH_FIELD_LOG (NAME);

CREATE INDEX IDX_S_N_EXPIRED ON CRAWLING_SESSION (NAME, EXPIRED_TIME);

CREATE SEQUENCE WEB_CRAWLING_CONFIG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FILE_CRAWLING_CONFIG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE JOB_LOG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE SCHEDULED_JOB_SEQ START WITH 5 INCREMENT BY 50;
CREATE SEQUENCE PATH_MAPPING_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE CRAWLING_SESSION_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE OVERLAPPING_HOST_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE REQUEST_HEADER_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE BOOST_DOCUMENT_RULE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE KEY_MATCH_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE WEB_AUTHENTICATION_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE CRAWLING_SESSION_INFO_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE LABEL_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FILE_CONFIG_TO_LABEL_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE WEB_CONFIG_TO_LABEL_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE ROLE_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FILE_CONFIG_TO_ROLE_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE WEB_CONFIG_TO_ROLE_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE DATA_CRAWLING_CONFIG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE DATA_CONFIG_TO_ROLE_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE DATA_CONFIG_TO_LABEL_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE USER_INFO_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE SEARCH_LOG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE LABEL_TYPE_TO_ROLE_TYPE_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE CLICK_LOG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FAILURE_URL_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FILE_AUTHENTICATION_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE SEARCH_FIELD_LOG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE FAVORITE_LOG_SEQ START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE SUGGEST_BAD_WORD START WITH 1 INCREMENT BY 50;
CREATE SEQUENCE SUGGEST_ELEVATE_WORD START WITH 1 INCREMENT BY 50;

INSERT INTO SCHEDULED_JOB (ID, NAME, TARGET, CRON_EXPRESSION, SCRIPT_TYPE, SCRIPT_DATA, CRAWLER, JOB_LOGGING, AVAILABLE, SORT_ORDER, CREATED_BY, CREATED_TIME, UPDATED_BY, UPDATED_TIME, VERSION_NO) VALUES (1, 'Crawler', 'all', '0 0 0 * * ?', 'groovy', 'return container.getComponent("crawlJob").execute(executor);', 'T', 'T', 'T', 0, 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 0);
INSERT INTO SCHEDULED_JOB (ID, NAME, TARGET, CRON_EXPRESSION, SCRIPT_TYPE, SCRIPT_DATA, CRAWLER, JOB_LOGGING, AVAILABLE, SORT_ORDER, CREATED_BY, CREATED_TIME, UPDATED_BY, UPDATED_TIME, VERSION_NO) VALUES (2, 'Minutely Tasks', 'all', '0 * * * * ?', 'groovy', 'return container.getComponent("aggregateLogJob").execute();', 'F', 'F', 'T', 10, 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 0);
INSERT INTO SCHEDULED_JOB (ID, NAME, TARGET, CRON_EXPRESSION, SCRIPT_TYPE, SCRIPT_DATA, CRAWLER, JOB_LOGGING, AVAILABLE, SORT_ORDER, CREATED_BY, CREATED_TIME, UPDATED_BY, UPDATED_TIME, VERSION_NO) VALUES (3, 'Hourly Tasks', 'all', '0 0 * * * ?', 'groovy', 'return container.getComponent("updateStatsJob").execute()+container.getComponent("updateHotWordJob").execute();', 'F', 'F', 'T', 20, 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 0);
INSERT INTO SCHEDULED_JOB (ID, NAME, TARGET, CRON_EXPRESSION, SCRIPT_TYPE, SCRIPT_DATA, CRAWLER, JOB_LOGGING, AVAILABLE, SORT_ORDER, CREATED_BY, CREATED_TIME, UPDATED_BY, UPDATED_TIME, VERSION_NO) VALUES (4, 'Daily Tasks', 'all', '0 0 0 * * ?', 'groovy', 'return container.getComponent("purgeLogJob").execute();', 'F', 'F', 'T', 30, 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 'system', to_date('2000-01-01', 'yyyy-MM-dd'), 0);

